#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityGetRichCFG.h"
std::auto_ptr<M_ActivityGetRichCFG> M_ActivityGetRichCFG::msSingleton(nullptr);

int M_ActivityGetRichCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityGetRichCFGData* M_ActivityGetRichCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityGetRichCFGData>& M_ActivityGetRichCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityGetRichCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityGetRichCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityGetRichCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mWeight = element->IntAttribute("Weight");
		data.mRate = element->IntAttribute("Rate");
		data.mGold = element->IntAttribute("Gold");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityGetRichCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityGetRichCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityGetRichCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityGetRichCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityGetRichCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readInt(L, "Rate", data.mRate);
		LuaCfgHelper::readInt(L, "Gold", data.mGold);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityGetRichCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityGetRichCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityGetRichCFG* M_ActivityGetRichCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityGetRichCFG());
	}
	return msSingleton.get();
}

void M_ActivityGetRichCFG::Release()
{
	msSingleton.reset(nullptr);
}
